require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_NFS_XDR_H)) {
    eval 'sub _LINUX_NFS_XDR_H () {1;}' unless defined(&_LINUX_NFS_XDR_H);
    require 'linux/sunrpc/xprt.ph';
    require 'linux/nfsacl.ph';
    eval 'sub NFS_MAX_FILE_IO_SIZE () {(1048576);}' unless defined(&NFS_MAX_FILE_IO_SIZE);
    eval 'sub NFS_DEF_FILE_IO_SIZE () {(4096);}' unless defined(&NFS_DEF_FILE_IO_SIZE);
    eval 'sub NFS_MIN_FILE_IO_SIZE () {(1024);}' unless defined(&NFS_MIN_FILE_IO_SIZE);
    eval 'sub NFS_ATTR_FATTR_TYPE () {(1 << 0);}' unless defined(&NFS_ATTR_FATTR_TYPE);
    eval 'sub NFS_ATTR_FATTR_MODE () {(1 << 1);}' unless defined(&NFS_ATTR_FATTR_MODE);
    eval 'sub NFS_ATTR_FATTR_NLINK () {(1 << 2);}' unless defined(&NFS_ATTR_FATTR_NLINK);
    eval 'sub NFS_ATTR_FATTR_OWNER () {(1 << 3);}' unless defined(&NFS_ATTR_FATTR_OWNER);
    eval 'sub NFS_ATTR_FATTR_GROUP () {(1 << 4);}' unless defined(&NFS_ATTR_FATTR_GROUP);
    eval 'sub NFS_ATTR_FATTR_RDEV () {(1 << 5);}' unless defined(&NFS_ATTR_FATTR_RDEV);
    eval 'sub NFS_ATTR_FATTR_SIZE () {(1 << 6);}' unless defined(&NFS_ATTR_FATTR_SIZE);
    eval 'sub NFS_ATTR_FATTR_PRESIZE () {(1 << 7);}' unless defined(&NFS_ATTR_FATTR_PRESIZE);
    eval 'sub NFS_ATTR_FATTR_BLOCKS_USED () {(1 << 8);}' unless defined(&NFS_ATTR_FATTR_BLOCKS_USED);
    eval 'sub NFS_ATTR_FATTR_SPACE_USED () {(1 << 9);}' unless defined(&NFS_ATTR_FATTR_SPACE_USED);
    eval 'sub NFS_ATTR_FATTR_FSID () {(1 << 10);}' unless defined(&NFS_ATTR_FATTR_FSID);
    eval 'sub NFS_ATTR_FATTR_FILEID () {(1 << 11);}' unless defined(&NFS_ATTR_FATTR_FILEID);
    eval 'sub NFS_ATTR_FATTR_ATIME () {(1 << 12);}' unless defined(&NFS_ATTR_FATTR_ATIME);
    eval 'sub NFS_ATTR_FATTR_MTIME () {(1 << 13);}' unless defined(&NFS_ATTR_FATTR_MTIME);
    eval 'sub NFS_ATTR_FATTR_CTIME () {(1 << 14);}' unless defined(&NFS_ATTR_FATTR_CTIME);
    eval 'sub NFS_ATTR_FATTR_PREMTIME () {(1 << 15);}' unless defined(&NFS_ATTR_FATTR_PREMTIME);
    eval 'sub NFS_ATTR_FATTR_PRECTIME () {(1 << 16);}' unless defined(&NFS_ATTR_FATTR_PRECTIME);
    eval 'sub NFS_ATTR_FATTR_CHANGE () {(1 << 17);}' unless defined(&NFS_ATTR_FATTR_CHANGE);
    eval 'sub NFS_ATTR_FATTR_PRECHANGE () {(1 << 18);}' unless defined(&NFS_ATTR_FATTR_PRECHANGE);
    eval 'sub NFS_ATTR_FATTR_V4_REFERRAL () {(1 << 19);}' unless defined(&NFS_ATTR_FATTR_V4_REFERRAL);
    eval 'sub NFS_ATTR_FATTR_OWNER_NAME () {(1 << 22);}' unless defined(&NFS_ATTR_FATTR_OWNER_NAME);
    eval 'sub NFS_ATTR_FATTR_GROUP_NAME () {(1 << 23);}' unless defined(&NFS_ATTR_FATTR_GROUP_NAME);
    eval 'sub NFS_ATTR_FATTR () {( &NFS_ATTR_FATTR_TYPE |  &NFS_ATTR_FATTR_MODE |  &NFS_ATTR_FATTR_NLINK |  &NFS_ATTR_FATTR_OWNER |  &NFS_ATTR_FATTR_GROUP |  &NFS_ATTR_FATTR_RDEV |  &NFS_ATTR_FATTR_SIZE |  &NFS_ATTR_FATTR_FSID |  &NFS_ATTR_FATTR_FILEID |  &NFS_ATTR_FATTR_ATIME |  &NFS_ATTR_FATTR_MTIME |  &NFS_ATTR_FATTR_CTIME);}' unless defined(&NFS_ATTR_FATTR);
    eval 'sub NFS_ATTR_FATTR_V2 () {( &NFS_ATTR_FATTR |  &NFS_ATTR_FATTR_BLOCKS_USED);}' unless defined(&NFS_ATTR_FATTR_V2);
    eval 'sub NFS_ATTR_FATTR_V3 () {( &NFS_ATTR_FATTR |  &NFS_ATTR_FATTR_SPACE_USED);}' unless defined(&NFS_ATTR_FATTR_V3);
    eval 'sub NFS_ATTR_FATTR_V4 () {( &NFS_ATTR_FATTR |  &NFS_ATTR_FATTR_SPACE_USED |  &NFS_ATTR_FATTR_CHANGE);}' unless defined(&NFS_ATTR_FATTR_V4);
    if(defined(&CONFIG_NFS_V4)) {
	eval 'sub NFS4_PATHNAME_MAXCOMPONENTS () {512;}' unless defined(&NFS4_PATHNAME_MAXCOMPONENTS);
	eval 'sub NFS4_FS_LOCATION_MAXSERVERS () {10;}' unless defined(&NFS4_FS_LOCATION_MAXSERVERS);
	eval 'sub NFS4_FS_LOCATIONS_MAXENTRIES () {10;}' unless defined(&NFS4_FS_LOCATIONS_MAXENTRIES);
    }
    eval 'sub NFS_PAGEVEC_SIZE () {(8);}' unless defined(&NFS_PAGEVEC_SIZE);
    if(defined(&CONFIG_NFS_V4)) {
    }
    if(defined(&CONFIG_NFS_V4)) {
    }
    eval 'sub NFS_CALL {
        my($op, $inode, $args) = @_;
	    eval q( &NFS_PROTO($inode)->$op $args);
    }' unless defined(&NFS_CALL);
}
1;
